<?php

namespace Ems\Controllers;

use Exception\Messages;
use Service\LogService;
use Service\OAuth\OAuthCustomImpl;
use Zeedhi\Framework\Controller\Simple;
use Zeedhi\Framework\HTTP\Kernel;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO;


use Ems\Services\OcupacaoService;

class OcupacaoController {

    /** @var ocupacaoService */
    protected $ocupacaoService;
    
    public function __construct(EntityManager $entityManager, OcupacaoService $ocupacaoService) {
        $this->entityManager        = $entityManager;
        $this->ocupacaoService   = $ocupacaoService;
    }
    
    public function getMotivoOcupa(Request\Row $request, Response $response) {
        try {

            $dados = $this->ocupacaoService->getMotivoOcupa();

            $response->addDataSet(new DataSet('getMotivoOcupa', $dados));

        } catch (\Exception $e) {
            $response->addMessage(new DTO\Response\Message($e->getMessage(), DTO\Response\Message::TYPE_ERROR));
        }
    }
    
    public function getOcupacao(Request\Row $request, Response $response) {
        try {

            $dados = $this->ocupacaoService->getOcupacao();

            $response->addDataSet(new DataSet('getOcupacao', $dados));

        } catch (\Exception $e) {
            $response->addMessage(new DTO\Response\Message($e->getMessage(), DTO\Response\Message::TYPE_ERROR));
        }
    }


}
