<?php

namespace HCM\FPA\Repository;

use Doctrine\ORM\EntityManager;
use HCM\Util\Util;

class RelatCustomPensionistaRepository {

    protected  $connection;
    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
 /**
     * @return array
     */

     public function getRelatCustomPensionista($parameters) {

        $sql = "    
        SELECT VH.NRESTRUTLEGAL,
        EML.NMESTRUTURAM NMESTRUTLEGAL,
        ET.NRESTRUTURAM NRTOMADOR,
        ET.NMESTRUTURAM NMTOMADOR,
        EG.NRESTRUTURAM NRESTRUTGEREN,
        EG.NMESTRUTURAM NMESTRUTGEREN,
        VM.CDMATRICULA,
        VM.NRVINCULOM,
        VM.NMVINCULOM,
        TO_CHAR(VM.DTADMISSAOVINC, 'DD/MM/YYYY') DTADMISSAOVINC,
        TO_CHAR(VM.DTRESCISAOVINC,'DD/MM/YYYY') DTRESCISAOVINC,
        P.NMPESSOA,
        P.NRCPFPESSOA,
        C.CDBANCO,
        C.CDAGENCIA,
        C.CDCONTCORR,
        DECODE(C.NRTPCONTCORR, 1, 'CONTA DE MOVIMENTACAO', 2, 'CNAB', 3, 'SALARIO', 4, 'PENSAO JUDICIAL') TPCONTCORR,
        B.NMBANCO, 
        A.NMAGENCIA,
        :P_DTVENCIMENTO DTVENCIMENTO,
        TPR.NMTIPORELACIONA,
        TPM.NMTIPOMOVIMENT,
        SUM(VREVENTOFOLHA) TOTAL
FROM GPE_VINCULOM VM
JOIN GPE_VINCULOH VH
   ON VH.NRVINCULOM = VM.NRVINCULOM
       AND VH.NRORG = VM.NRORG
       AND VH.DTMESCOMPETENC IN 
   (SELECT MAX(DTMESCOMPETENC)
   FROM GPE_VINCULOH VIH
   WHERE VIH.NRVINCULOM = VH.NRVINCULOM
           AND VIH.NRORG = VH.NRORG
           AND VIH.DTMESCOMPETENC <= :P_DTMESCOMPETENC) -- /ESTRUTURA LEGAL/
LEFT JOIN ESTRUTURAM EML
   ON EML.NRORG = VM.NRORG
       AND EML.NRESTRUTURAM = VH.NRESTRUTLEGAL
LEFT JOIN ESTRUTURAH EHL
   ON EHL.NRORG = VM.NRORG
       AND EHL.NRESTRUTURAM = EML.NRESTRUTURAM
       AND EHL.DTMESCOMPETENC = 
   (SELECT MAX(DTMESCOMPETENC)
   FROM ESTRUTURAH
   WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
           AND NRORG = VM.NRORG
           AND NRESTRUTURAM = EML.NRESTRUTURAM )
LEFT JOIN ESTRUTURAM EG
   ON EG.NRESTRUTURAM = VH.NRESTRUTGEREN
       AND EG.NRORG = VM.NRORG
LEFT JOIN TIPOHIERARQORG THO
   ON THO.NRORG IN ( 0, VM.NRORG )
       AND THO.NRTIPOESTRUTSUP = NVL(:P_NRTIPOESTRUTOMADOR, 7)
       AND THO.NRTIPOESTRUTREL = 
   (SELECT NRTPESTRUTGEREN
   FROM GPE_PARAMORG
   WHERE NRORG = VM.NRORG )
LEFT JOIN HIERARQUIAORG HO
   ON HO.NRORG = VM.NRORG
       AND HO.NRTIPOHIERARQORG = THO.NRTIPOHIERARQORG
       AND HO.NRESTRUTURAMREL = VH.NRESTRUTGEREN
       AND HO.DTINIVIGENCIA <= last_day(:P_DTMESCOMPETENC)
       AND (HO.DTFIMVIGENCIA IS NULL OR HO.DTFIMVIGENCIA >= :P_DTMESCOMPETENC)
LEFT JOIN ESTRUTURAM ET
   ON ET.NRESTRUTURAM = HO.NRESTRUTURAMSUP
       AND ET.NRORG = VM.NRORG
LEFT JOIN GPE_PESSOA PM
   ON PM.NRORG = :P_NRORG
       AND PM.NRPESSOA = VM.NRPESSOA
LEFT JOIN RELACIONAPARC R
   ON R.NRORG = :P_NRORG
       AND R.NRPARCNEGOCIO = PM.NRPARCNEGOCIO
       AND R.NRTIPORELACIONA = 6
LEFT JOIN TIPORELACIONA TPR
   ON TPR.NRORG IN (0, R.NRORG)
       AND TPR.NRTIPORELACIONA = R.NRTIPORELACIONA
LEFT JOIN GPE_PESSOAH P
   ON P.NRORG = :P_NRORG
       AND P.NRPESSOA = 
   (SELECT NRPESSOA
   FROM GPE_PESSOA PE
   WHERE PE.NRORG = :P_NRORG
           AND NRPARCNEGOCIO = R.NRPARCNEGRELAC)
       AND P.DTMESCOMPETENC = 
   (SELECT MAX(PP.DTMESCOMPETENC)
   FROM GPE_PESSOAH PP
   WHERE PP.NRORG = :P_NRORG
           AND PP.NRPESSOA = P.NRPESSOA)
LEFT JOIN CONTCORRPARC C
   ON C.NRORG = :P_NRORG
       AND C.NRPARCNEGOCIO = R.NRPARCNEGRELAC
       AND C.IDATIVO = 'S'
LEFT JOIN BANCO B
   ON B.CDBANCO = C.CDBANCO
       AND (B.NRORG = :P_NRORG
       OR B.NRORG = :P_NRORG_PADRAO)
LEFT JOIN AGENCIA A
   ON A.CDAGENCIA = C.CDAGENCIA
       AND A.CDBANCO = C.CDBANCO
       AND (A.NRORG = :P_NRORG
       OR A.NRORG = :P_NRORG_PADRAO)
JOIN FPA_ITECALCFOLHA ICF
   ON ICF.NRORG = VM.NRORG
       AND ICF.NRVINCULOM = VM.NRVINCULOM
       AND ICF.IDEVENDEMONCALC = 'N'
       AND ROUND(ICF.VREVENTOFOLHA, 2) <> 0
       AND ICF.NREVENTOM IN 
   (SELECT NREVENTOM
   FROM FPA_INCIDEVENTO
   WHERE NRTIPOINCIDE = 132
   AND NRORG IN (:P_NRORG,0))
JOIN FPA_CALCULOFOLHA CF
   ON CF.NRORG = VM.NRORG
       AND CF.NRCALCULOFOLHA = ICF.NRCALCULOFOLHA
       AND CF.NRTPMODALIDCAL = :P_NRTPMODALIDCAL
       AND CF.NROCORRECAL = :P_NROCORRECAL
       AND CF.NRTIPOMOVIMENT = :P_NRTIPOMOVIMENT
       AND CF.DTOCORRENCIA = :P_DTMESCOMPETENC
LEFT JOIN FPA_TIPOMOVIMENT TPM
       ON ( TPM.NRORG = VM.NRORG OR TPM.NRORG = 0 )
       AND TPM.NRTIPOMOVIMENT = CF.NRTIPOMOVIMENT
WHERE VM.NRORG = :P_NRORG
       AND ( INSTR(','||:P_NRVINCULOM||',', ','||VM.NRVINCULOM||',' ) > 0
       OR :P_NRVINCULOM IS NULL )
       AND ( INSTR(','||:P_NRESTRUTLEGAL||',', ','||VH.NRESTRUTLEGAL||',' ) > 0
       OR :P_NRESTRUTLEGAL IS NULL )
       AND ( INSTR(','||:P_NRESTRUTGEREN||',', ','||VH.NRESTRUTGEREN||',' ) > 0
       OR :P_NRESTRUTGEREN IS NULL )
GROUP BY  VH.NRESTRUTLEGAL, EML.NMESTRUTURAM, ET.NRESTRUTURAM, ET.NMESTRUTURAM, EG.NRESTRUTURAM, EG.NMESTRUTURAM, VM.CDMATRICULA, VM.NRVINCULOM, VM.NMVINCULOM, VM.DTADMISSAOVINC, VM.DTRESCISAOVINC, P.NMPESSOA, P.NRCPFPESSOA, C.CDBANCO, C.NRTPCONTCORR, C.CDAGENCIA, C.CDCONTCORR, TPR.NMTIPORELACIONA, B.NMBANCO, A.NMAGENCIA, TPM.NMTIPOMOVIMENT
    ";
        
        $query = $this->entityManager->getConnection()->prepare($sql);
        
        $query->execute($parameters);
        
        return $query->fetchAll();
    }
}
        
 

