<?php
/**
 * Responsável pela tela de relatórios gerais do HCM
 * Rafael Pickbrenner
 * 28/10/2016
 * 
 * 19/06/2018 Funcionalidade para download de arquivo/relatório. Emissão em outros formatos. Escolha da extensão do arquivo gerado.
 */

namespace HCM\Geral\Controllers;

use HCM\Geral\Services\HcmManualService;
use Zeedhi\Framework\DTO;
use HCM\Util\HCMParameters;

class HcmManualController {

    const FORMAT_PDF = '.pdf';

    protected $service;
    protected $hcmParameters;

    public function __construct(HcmManualService $hcmManualService, HCMParameters $hcmParameters){
        $this->service       = $hcmManualService;
        $this->hcmParameters = $hcmParameters;
    }
    
    public function getHcmManual(DTO\Request\Row $request, DTO\Response $response){
        try {
            $row = $request->getRow();
            
            $filesToDownload = $this->service->getHcmManual($row);

            $isZipFile = gettype($filesToDownload) == "string";

            if ($isZipFile) {
                $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('zip', array($filesToDownload)));
            } else {
                $filesToDownload = array('NMARQUIVO' => $filesToDownload);
                $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('arquivo', $filesToDownload));
            }
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
    
}